#include <vector>
#include <set>
#include <iostream>
#include <iterator>

struct less {
    bool operator() (int a, int b) {
        return a < b;
    }
};

struct greater {
    bool operator() (int a, int b) {
        return a > b;
    }
};

bool is_less (int a, int b) {
    return a < b;
}

bool is_greater (int a, int b) {
    return a > b;
}

int main()
{
    std::vector<int> a {9, 8, 7, 4, 2, 3, 4, 5, 6, 7, 3, 4, 5, 6, 2, 1, 8, 6};

    std::set<int> b;

    for (auto i : a) 
        b.insert(i);

    std::cout << "b: ";
    for (auto i : b)
        std::cout << i << " ";
    std::cout << std::endl;

    // toto je implicitni razeni prvku kontejneru, je tu jen na ukazku 
    std::set<int, less> c;
    std::copy (a.begin(), a.end(), std::inserter(c, c.begin()));
    std::cout << "c: ";
    std::copy (c.begin(), c.end(), std::ostream_iterator<int>(std::cout, " "));
    std::cout << std::endl;

    std::set<int, greater> d;

    for (auto i : a) 
        d.insert(i);

    std::cout << "d: ";
    for (auto i : d)
        std::cout << i << " ";
    std::cout << std::endl;

    std::set<int, bool (*) (int, int)> x(is_less);
    std::set<int, bool (*) (int, int)> y(is_greater);

    return 0;
}
