#include <iostream>
#include <numeric>
#include <iterator>

// pro vyzkouseni nektereho z algoritmu definujte makra A, B, C, nebo D

int multiply (int a, int b) {
    return a * b;
}

std::pair<int, int> avg (std::pair<int, int> a, int b) {
    // v paru a budu udrzovat hodnotu souctu a poctu cisel na vstupu
    return std::make_pair(a.first + b, a.second + 1);
}

int main() {
#ifdef A
    // konvencni reseni nacitani vstupnich dat z STDIO
    int sum = 0, x;
    while (std::cin >> x) {
        sum += x;
    }
    
    std::cout << "suma: " << sum << "\n";
#endif

#ifdef B
    std::cout << "zadej cisla: ";
    std::cout << std::accumulate(std::istream_iterator<int>(std::cin), std::istream_iterator<int>(), 0) << std::endl;
#endif

#ifdef C
    // dalsim argumentem accumulate muze byt ukazatel na funkci / funktor, ktery provede operaci s po sobe nasledujicimi 
    // prvky, ziskanymi behem iterace
    // uloha: soucin cisel na vstupu
    std::cout << std::accumulate(std::istream_iterator<int>(std::cin), std::istream_iterator<int>(), 1, multiply) << std::endl; 
#endif

#ifdef D
    // uloha: vypocet aritmetickeho prumeru cisel na standardnim vstupu
    std::pair<int, int> x = std::accumulate(std::istream_iterator<int>(std::cin), std::istream_iterator<int>(), std::make_pair(0, 0), avg);
    std::cout << (double) x.first / x.second << std::endl;
#endif
    return 0;
}
